#!/usr/bin/perl
#--------------------
# PSMT 2.3-4
# 2013.03.01 update
# 2016.12.09 DBեκ.dir,.pagξˤб
#---------------------------------------
# all_clients.pl
# 
# ٤Ƥδоݤ˥ޥɤդ륹ץ
# ڽ񼰡
#  all_clients.pl command parameta [-g list_group] [-i interval] [-f list_file]
#
use Fcntl;
use AnyDBM_File;
use Socket;

$command = shift;
$param = shift;
while($opt=shift) {
    $val = shift;
    if ( $val eq "" ) {
        print "usage: all_clients.pl command parameta [-g list_group] [-i interval] [-f list_file]\n";
        exit(1);
    } elsif ( $opt !~ /^\-[gif]/ ) {
        print "Invarid option\n";
        print "usage: all_clients.pl command parameta [-g list_group] [-i interval] [-f list_file]\n";
        exit(1);
    } else {
        if($opt eq "-g") {
            $group = $val;
        } elsif ( $opt eq "-i" ) {
            $interval = $val;
        } elsif ( $opt eq "-f" ) {
            $list_file = $val;
        }
    }
}

$manager_dir = "/var/www/manager/data";
$launcher = "/var/www/manager/bin/launcher.sh";
$temp_file = "/tmp/command_list_$$.csv";
$max_command = 10;

if ( $list_file ) {
    if ( -f $list_file ) {
        open(DATA,">$temp_file");
        open(LIST,$list_file);
        $g = 1;
        $n = 0;
        while(<LIST>) {
            chomp;
            next if /^$/;
            print DATA "$_,$g\n";
            $n++;
            if ( $n == $max_command ) {
                $n = 0;
                $g++;
            }
        }
        close(DATA);
        close(LIST);
        $data_file = $temp_file;
    } else {
        print "List file not found($list_file)\n";
        exit(1);
    }
} else {
    $data_file = "$manager_dir/update_list.csv";
}

$check_db_file = "$manager_dir/${command}_check_list";
$check_file = "$manager_dir/${command}_check_file";
$interval = 300 unless $interval;
$flag = 0;

if ( -f "$check_db_file" || -f "$check_db_file.dir" || -f "$check_db_file.db" ) {
    tie( %check_data, 'AnyDBM_File', $check_db_file, O_RDONLY, 0644 );
    foreach(sort keys %check_data) {
        $flag++ if $check_data{$_} == 0;
    }
    untie(%check_data);
    if ( $flag == 0 ) {
         unlink("$check_db_file") if -f "$check_db_file";
         unlink("$check_db_file.dir") if -f "$check_db_file.dir";
         unlink("$check_db_file.pag") if -f "$check_db_file.pag";
         unlink("$check_db_file.db") if -f "$check_db_file.db";
    }
}

if ( -f $check_file ) {
    print "The $command is processing.\n";
    exit(1);
}

print "---------------------\n";
print "command:\n";
print "$command $param\n";
print "---------------------\n";
print "prepare:\n";
$max = 0;
tie( %check_data, 'AnyDBM_File', $check_db_file, O_CREAT|O_RDWR, 0644 );
open(LIST,$data_file);
while(<LIST>) {
    chomp;
    ($host,$num) = split(/,/,$_);
    ($hostname,$alias,$atype,$len,@addrs) = gethostbyname($host);
    $ip = sprintf("%d.%d.%d.%d",unpack("CCCC",$addrs[0]));
    print "$ip -> $num";
    if ( $check_data{$ip} eq "" ) {
        $check_data{$ip} = 0;
    }
    if ( $group eq $num ) {
        if($check_data{$ip} == 0) {
            push(@{$list[0]},$ip);
            print " pushed\n";
        } else {
            print "\n";
        }
    } elsif ( $group eq "" ) {
        if($check_data{$ip} == 0) {
            push(@{$list[$num]},$ip);
            print " pushed\n";
        } else {
            print "\n";
        }
        $max = $num if $max < $num;
    }
}
close(LIST);

print "---------------------\n";
print "JOB:\n";
if ( $group ne "" ) {
    #print join(",",@{$list[0]}),"\n";
    $num = 0;
    foreach $ip (@{$list[0]}) {
        $check_data{$ip} = 2;
        system("$launcher $ip $command '$param'");
        print("$ip\n");
        $num++;
    }
    &result_check($num,$interval) if $num;
} else {
    foreach $n ( 1..$max ) {
        print "No.$n\n";
        #print join(",",@{$list[$n]}),"\n";
        $num = 0;
        foreach $ip (@{$list[$n]}) {
            $check_data{$ip} = 2;
            system("$launcher $ip $command '$param'");
            print("$ip\n");
            $num++;
        }
        &result_check($num,$interval) if $num;
    }
}
unlink($check_file);

# result
$total = 0;
$ok = 0;
$faile = 0;

foreach $ip (sort keys %check_data) {
    $res = $check_data{$ip};
    $total++;
    if($res eq "") {
        print "$ip : not $command\n";
        $faile++;
    } else {
        if($res == 1) {
            print "$ip : $command ok\n";
            $ok++;
        } elsif($res == 2) {
            print "$ip : $command timeout\n";
            $faile++;
        } else {
            print "$ip : $command faild\n";
            $faile++;
        }
    }
}
print <<EOF;
---------------------
summary:
     OK       : $ok
     Failed   : $faile
     Total    : $total
 
EOF
untie(%check_data);

if ( $total == $ok ) {
   unlink($check_db_file);
}

exit;

sub result_check {
    my ($num,$interval) = @_;
    my(@list);
    
    print "check $num client(s)\n";
    
    $|=1;
    while($interval) {
        sleep(5);print ".";
        $interval--;
        next unless -f $check_file;
        open(FILE,$check_file);
        @list = <FILE>;
        close(FILE);
        
        $flag = 0;
        foreach $d (@list) {
            chomp($d);
            ($ip,$stat) = split(/:/,$d);
            if ( $check_data{$ip} == 2 ) {
                if ( $stat eq "OK" ) {
                    $check_data{$ip} = 1;
                } else {
                    $check_data{$ip} = 0;
                }
                $num--;
            }
        }
        last if $num == 0;
    }
    print "\n";
    print "complete\n";
}
 