#!/usr/bin/perl
#--------------------
# PSMT 2.0
# 2013.03.01 update
# 
use Fcntl;
use AnyDBM_File;

$level = $ARGV[0];
$param = $ARGV[1];

$level = 0 if $level eq "";

print "Level $level rollback start ...\n\n";

$manager_dir = "/var/www/manager/data";
$clients_db_file = "$manager_dir/client_db";
$data_file = "$manager_dir/update_list.csv";
$check_db_file = "$manager_dir/check_list";
$command = "/var/www/manager/bin/rollback_launcher.sh";
$rollback = "/var/www/manager/bin/rollback.sh";
$OK_file = "$manager_dir/rollbackOK";
$check_file = "$manager_dir/rollback_check_file";
$interval = 300;
$flag = 0;
$rollback_data_pack_command = "/var/www/manager/bin/rollback_pack.sh";

if ( -f $check_db_file ) {
    tie( %check_data, 'AnyDBM_File', $check_db_file, O_RDONLY, 0644 );
    foreach(sort keys %check_data) {
        $flag++ if $check_data{$_} == 0;
    }
    untie(%check_data);
    if ( $flag == 0 ) {
         system("rm $check_db_file.*");
    }
}

if ( -f $check_file ) {
    print "The roolback is being processed.\n";
    exit(1);
}

open(OK,">$OK_file");
close(OK);

print "Rollback prepare:\n";

$rc = `$rollback_data_pack_command $level`;

unless (-f $data_file) {
    tie( %client_data, 'AnyDBM_File', $clients_db_file, O_RDONLY, 0644 );
    open(LIST,">$data_file");
    foreach $h (sort keys %client_data) {
        @D = split(/,/,$client_data{$h});
	print LIST "$D[0],1\n";
    }
    close(LIST);
    untie(%client_data);
}

$max = 0;
tie( %check_data, 'AnyDBM_File', $check_db_file, O_CREAT|O_RDWR, 0644 );

open(LIST,$data_file);
while(<LIST>) {
    s/\x0D|\x0A//;
    ($host,$num) = split(/,/,$_);
    ($hostname,$alias,$atype,$len,@addrs) = gethostbyname($host);
    $ip = sprintf("%d.%d.%d.%d",unpack("CCCC",$addrs[0]));
    if ( $check_data{$ip} eq "" ) {
        $check_data{$ip} = 0;
    }
    print "$ip -> $num ($check_data{$ip}) ";
    if ( $param eq $num ) {
        if($check_data{$ip} == 0) {
            push(@{$list[0]},$ip);
            print "pushed\n";
        } else {
            print "\n";
        }
    } elsif ( $param eq "" ) {
        if($check_data{$ip} == 0) {
            push(@{$list[$num]},$ip);
            print "pushed\n";
        } else {
            print "\n";
        }
        $max = $num if $max < $num;
    }
}
close(LIST);
print "---------------------\n";
print "Rollback JOB:\n";
if ( $param ne "" ) {
    print "No.$param\n";
    #print join(",",@{$list[0]}),"\n";
    $num = 0;
    foreach $ip (@{$list[0]}) {
        $check_data{$ip} = 2;
        system("$command $ip $level");
        print("$ip\n");
        $num++;
    }
    &result_check($num,$interval) if $num;
} else {
    foreach $n ( 1..$max ) {
        print "No.$n\n";
        #print join(",",@{$list[$n]}),"\n";
        $num = 0;
        foreach $ip (@{$list[$n]}) {
            $check_data{$ip} = 2;
            system("$command $ip $level");
            #print("$command $ip $level\n");
            print("$ip\n");
            $num++;
        }
        &result_check($num,$interval) if $num;
    }
}
unlink($check_file);

# result
$total = 0;
$ok = 0;
$faile = 0;

foreach $ip (sort keys %check_data) {
    $res = $check_data{$ip};
    $total++;
    if($res eq "") {
        print "$ip : not rollback\n";
        $faile++;
    } else {
        if($res == 1) {
            print "$ip : rollback ok\n";
            $ok++;
        } elsif($res == 2) {
            print "$ip : rollback timeout\n";
            $faile++;
        } else {
            print "$ip : rollback failed\n";
            $faile++;
        }
    }
}
print <<EOF;
---------------------
Rollback summary:
     OK       : $ok
     Failed   : $faile
     Total    : $total
 
done

EOF
untie(%client);
untie(%check_data);

if ( $total == 0 ) {
    system("rm $check_db_file.*");
    unlink($OK_file);
    print "No rollbacl clients.\n";
} elsif ( $total == $ok ) {
    system("rm $check_db_file.*");
    unlink($OK_file);
    # rollback
    system("$rollback $level");
    print "Success: PSMT update data rollback complete.\n";
} else {
    print "Error: see detail log file.\n";
}

exit;

sub result_check {
    my ($num,$interval) = @_;
    my(@list);
    
    print "check $num client(s)\n";
    
    $|=1;
    while($interval) {
        sleep(5);print ".";
        $interval--;
        next unless -f $check_file;
        open(FILE,$check_file);
        @list = <FILE>;
        close(FILE);
        
        $flag = 0;
        foreach $d (@list) {
            chomp($d);
            ($ip,$stat) = split(/:/,$d);
            if ( $check_data{$ip} == 2 ) {
                if ( $stat eq "OK" ) {
                    $check_data{$ip} = 1;
                } else {
                    $check_data{$ip} = 0;
                }
                $num--;
            }
        }
        last if $num == 0;
    }
    print "\n";
    print "complete\n";
}
 