#!/usr/bin/perl
use Fcntl;
use AnyDBM_File;
use Socket;

$param = $ARGV[0];

$manager_dir = "/var/www/manager/data";
$data_file = "$manager_dir/update_list.csv";
$check_db_file = "$manager_dir/check_list";
$update_url = "192.168.100.155/update/dist";
$update_command = "/var/www/manager/bin/update_launcher.sh";
$update_ok = "/var/www/manager/update/dist/updateOK";
$check_file = "$manager_dir/update_check_file";
$interval = 300;
$flag = 0;

if ( -f $check_db_file ) {
    tie( %check_data, 'AnyDBM_File', $check_db_file, O_RDONLY, 0644 );
    foreach(sort keys %check_data) {
        $flag++ if $check_data{$_} == 0;
    }
    untie(%check_data);
    if ( $flag == 0 ) {
         unlink($check_db_file);
    }
}

if ( -f $check_file ) {
    print "The update is being processed.\n";
    exit(1);
}

unless ( -f $data_file ) {
    print "Update list file not found.\n";
    exit(1);
}

unless ( -f $update_ok ) {
    open(UP,">$update_ok");
    close(UP);
}

print "---------------------\n";
print "Update prepare:\n";
$max = 0;
tie( %check_data, 'AnyDBM_File', $check_db_file, O_CREAT|O_RDWR, 0644 );
open(LIST,$data_file);
while(<LIST>) {
    s/\x0D|\x0A//;
    ($host,$num) = split(/,/,$_);
    ($hostname,$alias,$atype,$len,@addrs) = gethostbyname($host);
    $ip = sprintf("%d.%d.%d.%d",unpack("CCCC",$addrs[0]));
    print "$ip -> $num ($check_data{$ip}) ";
    if ( $check_data{$ip} eq "" ) {
        $check_data{$ip} = 0;
    }
    if ( $param eq $num ) {
        if($check_data{$ip} == 0) {
            push(@{$list[0]},$ip);
            print "pushed\n";
        } else {
            print "\n";
        }
    } elsif ( $param eq "" ) {
        if($check_data{$ip} == 0) {
            push(@{$list[$num]},$ip);
            print "pushed\n";
        } else {
            print "\n";
        }
        $max = $num if $max < $num;
    }
}
close(LIST);
print "---------------------\n";
print "Update JOB:\n";
if ( $param ne "" ) {
    print "No.$param\n";
    #print join(",",@{$list[0]}),"\n";
    $num = 0;
    foreach $ip (@{$list[0]}) {
        $check_data{$ip} = 2;
        system("$update_command $ip");
        #print("Lancher:$update_command $ip\n");
        print("$ip\n");
        $num++;
    }
    &result_check($num,$interval) if $num;
} else {
    foreach $n ( 1..$max ) {
        print "No.$n\n";
        #print join(",",@{$list[$n]}),"\n";
        $num = 0;
        foreach $ip (@{$list[$n]}) {
            $check_data{$ip} = 2;
            system("$update_command $ip");
            #print("Lancher:$update_command $ip\n");
            print("$ip\n");
            $num++;
        }
        &result_check($num,$interval) if $num;
    }
}
unlink($check_file);

# result
$total = 0;
$ok = 0;
$faile = 0;
foreach $ip (sort keys %check_data) {
    $res = $check_data{$ip};
    $total++;
    if($res eq "") {
        print "$ip : not update\n";
        $faile++;
    } else {
        if($res == 1) {
            print "$ip : update ok\n";
            $ok++;
        } elsif($res == 2) {
            print "$ip : update timeout\n";
            $faile++;
        } else {
            print "$ip : update faild\n";
            $faile++;
        }
    }
}
print <<EOF;
---------------------
update summary:
     OK       : $ok
     Failed   : $faile
     Total    : $total
 
EOF
untie(%check_data);

if ( $total == $ok ) {
    unlink($check_db_file);
    #unlink($update_ok);
    #system("/var/www/manager/bin/dist2backup.sh");
} else {
    system(qq(logger "all_update failed. (OK=$ok,NG=$faile)"));
    exit 1;
}
exit 0;

sub result_check {
    my ($num,$interval) = @_;
    my(@list);
    
    print "check $num client(s)\n";
    
    $|=1;
    while($interval) {
        sleep(5);print ".";
        $interval--;
        next unless -f $check_file;
        open(FILE,$check_file);
        @list = <FILE>;
        close(FILE);
        
        $flag = 0;
        foreach $d (@list) {
            chomp($d);
            ($ip,$stat) = split(/:/,$d);
            if ( $check_data{$ip} == 2 ) {
                if ( $stat eq "OK" ) {
                    $check_data{$ip} = 1;
                } else {
                    $check_data{$ip} = 0;
                }
                $num--;
            }
        }
        last if $num == 0;
    }
    print "\n";
    print "complete\n";
}
 