#!/usr/bin/perl
#--------------------------------
# showlic.pl
#
# ProScanCZXt@C̕\R}h
#
$keyfile = $ARGV[0];
$opt_d = $ARGV[1];

$KeyTable5_linux = '8TUV6EWHLFMA5GRSBCYZ2DP7JKQ43XN9';
$KeyTable6_linux = 'G6de7LMNp8QbjklmncfghH45iotRSTABZ-019$aWXYDKqrsOP2EFCuvwUVxyzIJ3';
$KeyTable5_aix = 'Z8TXL6U4SVHKB3EWCRQ2DP7Y5GMJFAN9';
$KeyTable6_aix = 'hH45RGA16de7STp8Qbj9$aWLMNcfgrsOklmBZ-0nP2EFCuvXYDKyzqwUVxiotIJ3';
@ps_tabel5 = ();
@ps_table6 = ();

if ( $keyfile =~ /aix/ ) {
    $KeyTable5 = $KeyTable5_aix;
    $KeyTable6 = $KeyTable6_aix
} elsif ( $keyfile =~ /x86/ ) {
    $KeyTable5 = $KeyTable5_linux;
    $KeyTable6 = $KeyTable6_linux
} else {
    $KeyTable5 = $KeyTable5_linux;
    $KeyTable6 = $KeyTable6_linux
}

@ps_table5 = $KeyTable5 =~ /(.)/g;
@ps_table6 = $KeyTable6 =~ /(.)/g;

open(IN,$keyfile);
$data = "";
read(IN,$buf,54);
$buf =~ s/(...)/&conv($1)/eg;
$data = $buf;
while(read(IN,$buf,38)) {
}

($reg_code,$common_data) = unpack("a24a12",$data);
if($reg_code =~ /^PSHB0[69]/ ) {
    ($type,$expire_date,$opt_num) = unpack("NNN",$common_data);
} elsif($reg_code =~ /^PSHB0[37]/) {
    ($type,$expire_date,$opt_num) = unpack("VVV",$common_data);
} else {
    print "Product code error\n";
    exit(1);
}
chop($reg_code);
$expire_str = &strtime($expire_date);

if ( $opt_d eq "v" ) {
    print "Registration code = $reg_code\n";
    print "License Type      = $type\n";
    print "Expire date = $expire_str\n";
} else {
    print "$reg_code,$type,$expire_str\n";
}
exit(0);

sub conv {
  my ($data) = @_;
  my @table5 = @ps_table5;
  my @table6 = @ps_table6;

  
  ($a,$b,$c) = $data =~ /(.)(.)(.)/;
  $i = 0;
  foreach(@table6) {
      last if $a eq $_;
      $i++;
  }
  $j = 0;
  foreach(@table5) {
      last if $b eq $_;
      $j++;
  }
  $k = 0;
  foreach(@table5) {
      last if $c eq $_;
      $k++;
  }
  $d = ($i * 1024 + $j * 32 + $k)^0xffff;
  $msb = int($d/256);
  $lsb = $d % 256;
  #printf STDERR "%s,%s,%s : %X,%X\n",$a,$b,$c,$msb,$lsb;
  return pack("CC",$msb,$lsb);
}

sub strtime {
    my ($t) = @_;
    
    my @T = localtime($t);
    return sprintf("%04d/%02d/%02d",$T[5]+1900,$T[4]+1,$T[3]);
}

