#!/bin/sh
PATH=/bin:/usr/bin:/usr/sbin:/usr/local/bin

FILE=$1
if [ "$FILE" = "" ]
then
    echo "file parameter error"
    exit 1
fi
if [ ! -f "$FILE" ]
then
    echo "file not found"
    exit 1
fi

UPDATE_DIR=/var/www/manager/update

if [ -d "$UPDATE_DIR/latest.back" ]
then
    rm -fr $UPDATE_DIR/latest.back
fi

if [ -d "$UPDATE_DIR/latest" ]
then
    mv $UPDATE_DIR/latest $UPDATE_DIR/latest.back
fi

cd $UPDATE_DIR
tar zxf "$FILE"
rm "$FILE"

latest=`awk -F, '{print $1,$2,$3}' $UPDATE_DIR/latest/VERSION`
if [ -f "$UPDATE_DIR/latest.back/VERSION" ]
then
    current=`awk -F, '{print $1,$2,$3}' $UPDATE_DIR/latest.back/VERSION`
fi
rm -fr $UPDATE_DIR/latest.back

if [ "$latest" = "$current" ]
then
    echo "up to date"
    exit 0
fi

echo "ok"
exit 0
