#!/usr/bin/perl
#--------------------
# PSMT 2.0
# 2013.03.01 update
# 
use Fcntl;
use AnyDBM_File;

$manager_dir = "/var/www/manager/data";
$command_dir = "/var/www/manager/bin";
$data_file = "$manager_dir/client_db";
$log_file = "$manager_dir/version_check.log";
$lock_file = "$manager_dir/version_check.lock";

if(symlink($log_file,$lock_file)==0) {
    exit;
}
unlink($log_file);
open(LOG,">$log_file");
select(LOG);
$|=1;
print LOG "version check start....<br>\n<hr>\n";
@ips = ();
@hosts = ();
tie( %client_data, 'AnyDBM_File', $data_file, O_RDONLY, 0644 );
foreach $host (sort keys %client_data) {
        @data = split(/,/,$client_data{$host});
	push(@ips,$data[0]);
	push(@hosts,$host);
	print LOG "check: $host:$data[0]<br>\n";
}
untie(%client_data);
print LOG "<hr>\nget status....<br>\n";
unless ( @hosts ) {
	print LOG "no client<br>\n";
}
$n = 0;
foreach (@hosts) {
	$ip = $ips[$n];
	$n++;
        print LOG "$n. $_($ip) - - - ";
        $res = `echo version | $command_dir/manager -a $ip`;
        if ( $res =~ /^OK/ ) {
            print LOG "OK!<br>\n";
#print LOG "[DEBUG] $res<br>[DEBUG] @data<br>[DEBUG] $command_dir/manager -a $data[0]<br>\n";
        } else {
            print LOG "Error!<br>\n";
        }
}
print LOG "<hr>\nversion check complete<br>\n";

close(LOG);
unlink($lock_file);
