#!/usr/bin/perl
#---------------------------------------------------------------------
# ProScan Manager Tool CGIモジュール
#---------------------------------------------------------------------
# コマンドログ
#---------------------------------------------------------------------
# Script name: result.cgi
# Create date: 2013/3/11(V1.0)
# Auther:       T.Oyamada
#---------------------------------------------------------------------
# Change:
#---------------------------------------------------------------------
# All Rights Reserved, Copyright (c) Promark Inc. 2005-2013
#---------------------------------------------------------------------
use strict;
use utf8;
use Encode;
use CGI;
use Time::Local;
#use encoding "utf8";

my $manager_dir = "/var/www/manager/data";
my $mirror_dir = "/var/www/manager/mirror";
my $command_dir = "/var/www/manager/bin";
my $mirror_command = "$mirror_dir/mirror.sh";
my $latest2dist_command = "$command_dir/latest2dist.sh";
my $rollback_command = "$command_dir/all_rollback.pl";
my $url = "/cgi-bin/manager.cgi";

my $query = new CGI;
my $type = $query->param('type');
my $results = "";

print "Content-Type: text/html\n\n";

print <<EOF;
<meta http-equiv="content-type" content="text/html;charset=UTF-8">
<head>
<title>ProScan Management Tool</title>
<style type="text/css">
A { text-decoration: none; }
</style>
<!-- $type -->
<script language="Javascript">
<!--
function WindowClose() {
    if ( window.opener ) window.opener.location.href = "$url";
    window.close();
}
//-->
</script>
</head>
<body>
EOF

if ( $type eq "mirror" ) {
    print qq(ミラーリングコマンド実行結果<br><hr><br><pre>\n);
    open(LOG,"$mirror_command|");
    select(LOG);$|=1;
    select(STDOUT);$|=1;
    while(<LOG>) {
        print;
    }
    close(LOG);
    print "</pre>\n";
} elsif ( $type eq "latest2dist" ) {
    print qq(最新版反映コマンド実行結果<br><hr><br><pre>\n);
    open(LOG,"$latest2dist_command|");
    select(LOG);$|=1;
    select(STDOUT);$|=1;
    while(<LOG>) {
        print;
    }
    close(LOG);
    print "</pre>\n";
} elsif ( $type =~ /rollback/ ) {
    my ($level) = $type =~ /rollback(\d)/;
    print qq(ロールバックコマンド実行結果(Level:$level)<br><hr><br><pre>\n);
    open(LOG,"$rollback_command $level|");
    select(LOG);$|=1;
    select(STDOUT);$|=1;
    while(<LOG>) {
        print;
    }
    close(LOG);
    print "</pre>\n";
} else {
    print qq(コマンドの指定が正しくありません。何も実行できませんでした。<br>\n);
}

print <<EOF;
<hr>
<input type="button" value="閉じる" onClick="WindowClose()">
</body>
</html>

EOF

