#!/bin/sh
MIRROR_DIR=/var/www/manager/mirror
TARGET=/var/www/manager/update/latest
SERVER_SETTING="$MIRROR_DIR/mirror.conf"
WGET=`which wget`
TEMP_DIR=/tmp/.mirror
LOG_LEVEL="local3.info"

if [ ! -f $SERVER_SETTING ]
then
	echo "$SERVER_SETTING file not found"
	exit 1
fi

HOST=`cat $SERVER_SETTING`
echo "download from $HOST"

if [ ! -d $TEMP_DIR ]
then
	mkdir $TEMP_DIR
fi
cd $TEMP_DIR

echo "mirror start..."
if [ -x "$WGET" ]
then
	$WGET -m http://$HOST/
	RC=$?
else
	echo "wget command failed"
	exit 1
fi

if [ $RC -ne 0 ]
then
	echo "mirror failed"
	logger -i -p $LOG_LEVEL -t PSMTmirror -- "PSMT mirror failed. See detail logfile."
	rm -rf $TEMP_DIR
	exit 1
fi
echo "mirror done"

find . -name 'index.html*' -exec rm {} \; > /dev/null 2>&1
echo "delete index.html files"
cd `ls`
rm -rf icons > /dev/null 2>&1
chown -R psmtadm:psmtadm . > /dev/null 2>&1
echo "copy to target..."
cp -pr * $TARGET 
rm -rf $TEMP_DIR > /dev/null 2>&1

echo "complete"

exit 0
