#!/usr/bin/perl
#---------------------------
# パスワード初期化　mkuser.pl
#
#  adminユーザのパスワードを初期化するコマンド
#　インストーラで使用しDBを更新する（無ければ新規に作成）
#
#　Usage: mkuser.pl [パスワード][タイプ][期限日数]
#
#　パスワードを省略すると"asdfpoiu"が設定される
#　タイプを省略すると"d"が設定される（d:DES、B:Blowfish）
#　※タイプだけを指定することはできない
# 期限日数のデフォルトは30日間
#
use Fcntl;
use AnyDBM_File;

$password = $ARGV[0];
$password = "asdfpoiu" unless $password;
$password_type = $ARGV[1];
$password_type = "d" unless $password_type;
$remain_days = $ARGV[2];
$remain_days = 30 unless $remain_days;

$manager_dir = "/var/www/manager";
$data_dir = "$manager_dir/data";
$user_db_file = "$data_dir/users_db";
$htpasswd = "$manager_dir/bin/psmt_passwd";

tie( %user_list, 'AnyDBM_File', $user_db_file, O_CREAT|O_RDWR, 0600 );
$now = time;
$expire = $now + 30 * 86400;
$crypt_pass = `$htpasswd -$password_type -n $password`;
chomp($crypt_pass);
$user_list{'admin'} = "$crypt_pass,$remain_days,$expire";
untie(%user_list);

