#!/bin/sh
#--------------------
# PSMT 2.3
# 2024.11.23 new
# 
#--------
# このスクリプトは、指定クライアントに対してロールバック指示を行うためのスクリプトです。
#
IP=$1
LEVEL=$2
DOCROOT=/var/www/html
DOWNLOAD=$DOCROOT/download
DATA_FILE=$DOWNLOAD/backup$LEVEL-vdf.tar.gz
MANAGER=/var/www/manager/bin/manager
PACK_COMMAND=/var/www/manager/bin/rollback_pack.sh

if [ "$IP" = "" ]
then
    echo "Please set target host"
    exit 1
fi

$PACK_COMMAND $LEVEL

if [ ! -f $DATA_FILE ]
then
    echo ERR
else
    RES=`echo rollback $LEVEL | $MANAGER -a $IP | grep OK`

    if [ "$RES" != "" ]
    then
    	echo OK
    else
    	echo NG
    fi
fi

exit 0
