#!/usr/bin/perl
#-----------------------------------------------------------
# PSMT manager 2.3 設定ファイル (build 13)
#-----------------------------------------------------------
#
package PSMTConfig;
#-----------------------------------------------------------
# 以下、必要に応じて設定を変更してください。

# PSMTサーバのIPアドレス
$manager_ipaddr = "192.168.100.155";

# アップデート用HTTPのポート番号
$update_port = 80;

# アップデートサーバのドキュメントルート
$document_root = "/var/www/html";

# 管理データ格納ディレクトリを指定します。verchk.cgiで指定したものと
# 同じディレクトリとなります。
$manager_dir = "/var/www/manager";

# wgetコマンドのパスを指定します。
$wget = "/usr/bin/wget";

# psmt_passwdコマンドのパスを指定します。
$htpasswd = "$manager_dir/bin/psmt_passwd";

# パスワードの暗号化タイプを指定します。
# d : DES
# B : Bcrypt
$crypt_opt = "d";

# PSMTのタイプを指定します。
# 0 : スレーブ
# 1 : マスタ
# 2 : ミラーリングできないクローズド環境
$master_flag = 1;

# スレーブの場合には、$latest_ver_fileを設定します。
$latest_ver_file = "";

# 最新バージョン管理サーバのアドレスを３つ指定します。
# 通常は以下のサーバで問題ありません。
$server1 = "clamav-latest.promark-inc.com";
$server2 = "clamav-latest-2.promark-inc.com";
$server3 = "update.promark-inc.com";

# 最新情報取得のタイムアウト値
# この値を大きくすると表示までに時間がかかる場合があります
$timeout = 5;

# アクセス許可端末
$allow = ".";

# リスト表示時の1ページの行数
$number_of_page = 10;

1;
